@ECHO OFF
::  Get the entry from the registry that says where the files are located


START /w regedit /e reg.txt HKEY_CURRENT_USER\Software\Light-O-Rama\Shared
TYPE reg.txt | FIND "UserDataPath" > "UserData#Path.bat"
ECHO SET LORPath=%%1>"UserDataPath.bat"
CALL "UserData#Path.bat"
DEL "UserDataPath.bat" > nul
DEL "UserData#Path.bat" > nul
DEL reg.txt > nul

::  Replace the \\ with \ - Probably not necessary but we won't take chances.
SET LORPath=%LORPath:\\=\%
::  Eliminate trailing quote
SET LORPath=%LORPath:~0,-1%

:: Read the weekly schedule
SET LORSchedFile=%LORPath%weeksched.lsc"
SET PrevWeekDay=99

ECHO Reading schedule file %LORSchedFile%

::  Now we need to read the schedule file and separate the lines.
::  Since the file is a single line, it is too long for us to parse with DOS variables
::  We will make use of the free program gawk to do this work for us.
::  I am sure that awk experts could do this a lot more easily but I not putting THAT
::  much effort into this.

GAWK "BEGIN { RS = \"),[(]\" } ; { print $0 } "  %LORSchedFile% > "LORSchedule_tmp.tmp"

SET /A NumberOfShows=0
SET /A NumberOfBadShows=0
::
:: Retrieve the show stop time, show name and show start time
::
FOR /F "tokens=1,5,6* delims=," %%A IN (LORSchedule_tmp.tmp) DO (
      CALL :CheckShows "%%A" "%%B" "%%C"
)
ECHO Number of Shows %NumberOfShows%
ECHO Number of Missing Shows %NumberOfBadShows%

DEL LORSchedule_tmp.tmp > nul
DEL LORShow_tmp.tmp > nul
DEL LORShow_tmp1.tmp > nul
DEL LORShow_tmp2.tmp > nul
DEL LORShow_tmp3.tmp > nul
DEL LORShow_tmp4.tmp > nul
DEL LORShow_tmp5.tmp > nul
DEL LORShow_tmp6.tmp > nul

EXIT /B


:CheckShows
::
:: We will read the list of shows created by the gawk

:: Any blank Lines?
IF %~1==() GOTO:EOF

SET ShowName=%~2"
SET ShowName="%ShowName:)=%


SET StartTimeCentiSeconds=%~3
SET StartTimeCentiSeconds=%StartTimeCentiSeconds:)=%
CALL :DateCalcs %StartTimeCentiSeconds%
ECHO.

IF NOT %PrevWeekDay%==%DayOfWeek% (
   ECHO.
   ECHO Processing Schedule for %WeekDay%  >CON
   ECHO START OF SHOWS FOR ..................  %WeekDay%  ................................
   SET PrevWeekDay=%DayOfWeek%
)

ECHO Checking Show - %ShowName%
ECHO Show Begins - %WeekDay% at %HourOfDay%:%MinuteofDay%.%TenthsOfSecond% %Meridian%

SET EndTimeCentiSeconds=%~1
SET EndTimeCentiSeconds=%EndTimeCentiSeconds:(=%
CALL :DateCalcs %EndTimeCentiSeconds%
ECHO Show Ends - %WeekDay% at %HourOfDay%:%MinuteofDay%.%TenthsOfSecond% %Meridian%

SET /A NumberofShows= NumberOfShows+1


IF NOT EXIST %ShowName% (
  ECHO Show does not exist %ShowName%
  SET /A NumberofBadShows= NumberOfBadShows+1 
) ELSE (
         CALL :CheckSequences
  )


GOTO:EOF

:DateCalcs
:: Get the scheduled day of the week and the time for use later
SET TimeInCentiseconds=%~1
SET /A DayOfWeek=%TimeInCentiseconds%/86400
IF %DayOfWeek%==0 (
  SET WeekDay=Sunday
)
IF %DayOfWeek%==1 (
  SET WeekDay=Monday
)
IF %DayOfWeek%==2 (
  SET WeekDay=Tuesday
)
IF %DayOfWeek%==3 (
  SET WeekDay=Wednesday
)
IF %DayOfWeek%==4 (
  SET WeekDay=Thursday
)
IF %DayOfWeek%==5 (
  SET WeekDay=Friday
)
IF %DayOfWeek%==6 (
  SET WeekDay=Saturday
)
SET /A MilitaryHourOfDay=(%TimeInCentiseconds%-(%DayOfWeek%*86400))/3600
SET Meridian=AM
IF %MilitaryHourOfDay% GEQ 12 (
   SET /A HourOfDay=%MilitaryHourOfDay%-12
   SET Meridian=PM
)
SET /A MinuteofDay=(%TimeInCentiseconds%-((%DayOfWeek%*86400)+(%MilitaryHourOfDay%*3600)))/60
SET /A TenthsOfSecond=%TenthsOfSecond%+900
SET TenthsOfSecond=%TenthsOfSecond:~-2%
SET /A TenthsOfSecond=%TimeInCentiseconds%-(((%DayOfWeek%*86400)+(%MilitaryHourOfDay%*3600))+(%MinuteOfDay%*60))
:: Format the minutes and tenths to be two positions
SET /A MinuteofDay=%MinuteofDay%+900
SET MinuteofDay=%MinuteofDay:~-2%
SET /A TenthsOfSecond=%TenthsOfSecond%+900
SET TenthsOfSecond=%TenthsOfSecond:~-2%

GOTO:EOF

:CheckSequences

GAWK "BEGIN { RS = \",\" } ; { print $0 } "  %ShowName% > LORShow_tmp6.tmp
GAWK "length($0) > 10"  LORShow_tmp6.tmp > LORShow_tmp5.tmp
GAWK "{gsub(/[&]/,\"I REPLACED AMPERSAND\");print}"  LORShow_tmp5.tmp > LORShow_tmp4.tmp
GAWK "{gsub(/[(]/,\"\");print}"  LORShow_tmp4.tmp > LORShow_tmp3.tmp
GAWK "{gsub(/[)]/,\"\");print}"  LORShow_tmp3.tmp > LORShow_tmp2.tmp
::  Light-O-Rama does not store ( or ) in their files.
::  Instead, they use *O to represent an 'opening' parenthesis and a *C to represent a 'closing'.
::  We will restore them so we can find the files.
GAWK "{gsub(/*O/,\"(\");print}"  LORShow_tmp2.tmp > LORShow_tmp1.tmp
GAWK "{gsub(/*C/,\")\");print}"  LORShow_tmp1.tmp > LORShow_tmp.tmp
)

SET /A NumberOfSequences=0
SET /A NumberOfBadSequences=0          

FOR /F "tokens=1 delims=  " %%s IN (LORShow_tmp.tmp) DO (
         CALL :CheckSeqFile "%%s"
)
ECHO Number of Sequences in show = %NumberOfSequences%
ECHO Number of Missing Sequences = %NumberOfBadSequences%


GOTO:EOF


:CheckSeqFile
::  Check the existence of the sequence that is defined in the show file

SET SeqName=%~1"
SET SeqName="%SeqName%

::  If there is a blank line, skip it
IF %SeqName%==() (GOTO:EOF)

SET /A NumberofSequences= %NumberOfSequences%+1

IF NOT EXIST %SeqName% (
  ECHO. Missing Sequence %SeqName% 
  SET /A NumberOfBadSequences= NumberOfBadSequences+1 
)

GOTO:EOF
